3D Bubble in JavaScript

Using ApexCharts with JavaScript

This 3D Bubble example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Seeded PRNG so the bubbles are identical on every load (stable snapshots).
var __seed = 0x3d0b7e21
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

// Each point is [date, conversionRate %, impressions]. The third value drives
// the bubble size, so a bigger bubble = more impressions that day.
function generateData(baseval, count, yrange, zrange) {
  var series = []
  for (var i = 0; i < count; i++) {
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min
    var z = Math.floor(rand() * (zrange.max - zrange.min + 1)) + zrange.min
    series.push([baseval, y, z])
    baseval += 86400000
  }
  return series
}

var options = {
  series: [
    {
      name: 'Search',
      data: generateData(
        new Date('01 Jun 2024 GMT').getTime(),
        20,
        { min: 35, max: 60 },
        { min: 40, max: 75 },
      ),
    },
    {
      name: 'Social',
      data: generateData(
        new Date('01 Jun 2024 GMT').getTime(),
        20,
        { min: 20, max: 45 },
        { min: 30, max: 70 },
      ),
    },
    {
      name: 'Email',
      data: generateData(
        new Date('01 Jun 2024 GMT').getTime(),
        20,
        { min: 10, max: 30 },
        { min: 15, max: 45 },
      ),
    },
    {
      name: 'Display',
      data: generateData(
        new Date('01 Jun 2024 GMT').getTime(),
        20,
        { min: 5, max: 25 },
        { min: 20, max: 60 },
      ),
    },
  ],
  chart: {
    height: 350,
    type: 'bubble',
  },
  dataLabels: {
    enabled: false,
  },
  fill: {
    type: 'gradient',
  },
  title: {
    text: 'Channel Performance Over Time',
  },
  subtitle: {
    text: 'Bubble size = daily impressions',
  },
  xaxis: {
    tickAmount: 12,
    type: 'datetime',
    labels: {
      rotate: 0,
    },
  },
  yaxis: {
    max: 70,
    title: {
      text: 'Conversion Rate (%)',
    },
  },
  theme: {
    palette: 'palette2',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

3D Bubble in React

Using ApexCharts with React

This 3D Bubble example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Seeded PRNG so the bubbles are identical on every load (stable snapshots).
var __seed = 0x3d0b7e21
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

// Each point is [date, conversionRate %, impressions]. The third value drives
// the bubble size, so a bigger bubble = more impressions that day.
function generateData(baseval, count, yrange, zrange) {
  var series = []
  for (var i = 0; i < count; i++) {
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min
    var z = Math.floor(rand() * (zrange.max - zrange.min + 1)) + zrange.min
    series.push([baseval, y, z])
    baseval += 86400000
  }
  return series
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Search',
        data: generateData(
          new Date('01 Jun 2024 GMT').getTime(),
          20,
          { min: 35, max: 60 },
          { min: 40, max: 75 },
        ),
      },
      {
        name: 'Social',
        data: generateData(
          new Date('01 Jun 2024 GMT').getTime(),
          20,
          { min: 20, max: 45 },
          { min: 30, max: 70 },
        ),
      },
      {
        name: 'Email',
        data: generateData(
          new Date('01 Jun 2024 GMT').getTime(),
          20,
          { min: 10, max: 30 },
          { min: 15, max: 45 },
        ),
      },
      {
        name: 'Display',
        data: generateData(
          new Date('01 Jun 2024 GMT').getTime(),
          20,
          { min: 5, max: 25 },
          { min: 20, max: 60 },
        ),
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'bubble',
      },
      dataLabels: {
        enabled: false,
      },
      fill: {
        type: 'gradient',
      },
      title: {
        text: 'Channel Performance Over Time',
      },
      subtitle: {
        text: 'Bubble size = daily impressions',
      },
      xaxis: {
        tickAmount: 12,
        type: 'datetime',
        labels: {
          rotate: 0,
        },
      },
      yaxis: {
        max: 70,
        title: {
          text: 'Conversion Rate (%)',
        },
      },
      theme: {
        palette: 'palette2',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bubble"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

3D Bubble in Vue

Using ApexCharts with Vue

This 3D Bubble example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bubble"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Seeded PRNG so the bubbles are identical on every load (stable snapshots).
var __seed = 0x3d0b7e21
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

// Each point is [date, conversionRate %, impressions]. The third value drives
// the bubble size, so a bigger bubble = more impressions that day.
function generateData(baseval, count, yrange, zrange) {
  var series = []
  for (var i = 0; i < count; i++) {
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min
    var z = Math.floor(rand() * (zrange.max - zrange.min + 1)) + zrange.min
    series.push([baseval, y, z])
    baseval += 86400000
  }
  return series
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Search',
          data: generateData(
            new Date('01 Jun 2024 GMT').getTime(),
            20,
            { min: 35, max: 60 },
            { min: 40, max: 75 },
          ),
        },
        {
          name: 'Social',
          data: generateData(
            new Date('01 Jun 2024 GMT').getTime(),
            20,
            { min: 20, max: 45 },
            { min: 30, max: 70 },
          ),
        },
        {
          name: 'Email',
          data: generateData(
            new Date('01 Jun 2024 GMT').getTime(),
            20,
            { min: 10, max: 30 },
            { min: 15, max: 45 },
          ),
        },
        {
          name: 'Display',
          data: generateData(
            new Date('01 Jun 2024 GMT').getTime(),
            20,
            { min: 5, max: 25 },
            { min: 20, max: 60 },
          ),
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'bubble',
        },
        dataLabels: {
          enabled: false,
        },
        fill: {
          type: 'gradient',
        },
        title: {
          text: 'Channel Performance Over Time',
        },
        subtitle: {
          text: 'Bubble size = daily impressions',
        },
        xaxis: {
          tickAmount: 12,
          type: 'datetime',
          labels: {
            rotate: 0,
          },
        },
        yaxis: {
          max: 70,
          title: {
            text: 'Conversion Rate (%)',
          },
        },
        theme: {
          palette: 'palette2',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

3D Bubble in Angular

Using ApexCharts with Angular

This 3D Bubble example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Search',
              data: generateData(
                new Date('01 Jun 2024 GMT').getTime(),
                20,
                { min: 35, max: 60 },
                { min: 40, max: 75 },
              ),
            },
            {
              name: 'Social',
              data: generateData(
                new Date('01 Jun 2024 GMT').getTime(),
                20,
                { min: 20, max: 45 },
                { min: 30, max: 70 },
              ),
            },
            {
              name: 'Email',
              data: generateData(
                new Date('01 Jun 2024 GMT').getTime(),
                20,
                { min: 10, max: 30 },
                { min: 15, max: 45 },
              ),
            },
            {
              name: 'Display',
              data: generateData(
                new Date('01 Jun 2024 GMT').getTime(),
                20,
                { min: 5, max: 25 },
                { min: 20, max: 60 },
              ),
            },
          ],
          chart: {
            height: 350,
            type: 'bubble',
          },
          dataLabels: {
            enabled: false,
          },
          fill: {
            type: 'gradient',
          },
          title: {
            text: 'Channel Performance Over Time',
          },
          subtitle: {
            text: 'Bubble size = daily impressions',
          },
          xaxis: {
            tickAmount: 12,
            type: 'datetime',
            labels: {
              rotate: 0,
            },
          },
          yaxis: {
            max: 70,
            title: {
              text: 'Conversion Rate (%)',
            },
          },
          theme: {
            palette: 'palette2',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}